'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Item = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsShallowCompare = require('react-addons-shallow-compare');

var _reactAddonsShallowCompare2 = _interopRequireDefault(_reactAddonsShallowCompare);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _notifiable = require('../notifiable');

var _notifiable2 = _interopRequireDefault(_notifiable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Item = exports.Item = function (_React$Component) {
  _inherits(Item, _React$Component);

  function Item(props) {
    _classCallCheck(this, Item);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Item).call(this));

    _this.closeNotification = props.closeNotification.bind(null, props.id);
    return _this;
  }

  _createClass(Item, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _reactAddonsShallowCompare2.default)(this, nextProps, nextState);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props;
      var dismiss = _props.dismiss;
      var dismissTimeout = _props.dismissTimeout;
      var onAdd = _props.onAdd;


      onAdd && onAdd();

      if (dismiss) {
        this.timeout = setTimeout(function () {
          _this2.closeNotification();
        }, dismissTimeout);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var onRemove = this.props.onRemove;


      onRemove && onRemove();

      clearInterval(this.timeout);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var title = _props2.title;
      var message = _props2.message;
      var theme = _props2.theme;
      var id = _props2.id;
      var type = _props2.type;
      var Template = _props2.Template;

      var actions = this._getActions();
      var itemTheme = theme(id, 'item');
      var hasTemplate = Template !== null;

      return _react2.default.createElement(
        'div',
        { key: itemTheme.key, className: (0, _classnames2.default)(itemTheme.className, type) },
        hasTemplate && _react2.default.createElement(Template, { title: title, message: message, actions: actions }),
        !hasTemplate && [_react2.default.createElement(
          'div',
          theme(id + '-texts', 'itemTexts'),
          _react2.default.createElement(
            'div',
            theme(id + '-title', 'itemTitle'),
            title
          ),
          _react2.default.createElement('div', _extends({}, theme(id + '-message', 'itemMessage'), {
            dangerouslySetInnerHTML: { __html: message } }))
        ), _react2.default.createElement(
          'div',
          theme(id + '-actions', 'itemActions'),
          actions
        )]
      );
    }
  }, {
    key: '_getActions',
    value: function _getActions() {
      var _this3 = this;

      var actions = this.props.actions;


      return actions.map(function (_ref, index) {
        var label = _ref.label;
        var callback = _ref.callback;
        return _react2.default.createElement(
          'button',
          {
            key: index,
            onClick: function onClick() {
              return callback ? callback(_this3.closeNotification) : _this3.closeNotification();
            } },
          label
        );
      });
    }
  }]);

  return Item;
}(_react2.default.Component);

Item.displayName = 'Item';
Item.propTypes = {
  dismiss: _react.PropTypes.bool.isRequired,
  dismissTimeout: _react.PropTypes.number.isRequired,
  closeNotification: _react.PropTypes.func.isRequired,
  id: _react.PropTypes.string.isRequired,
  title: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]).isRequired,
  message: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]).isRequired,
  onAdd: _react.PropTypes.func,
  onRemove: _react.PropTypes.func,
  actions: _react.PropTypes.array,
  type: _react.PropTypes.string,
  theme: _react.PropTypes.func.isRequired,
  Template: _react2.default.PropTypes.oneOfType([_react.PropTypes.element, _react.PropTypes.func])
};
exports.default = (0, _notifiable2.default)()(Item);