'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _notification = require('./notification');

var _notification2 = _interopRequireDefault(_notification);

var _reducerAndActions = require('./reducerAndActions');

var _reducerAndActions2 = _interopRequireDefault(_reducerAndActions);

var _reactThemeable = require('react-themeable');

var _reactThemeable2 = _interopRequireDefault(_reactThemeable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_THEME = {
  container: 'react-notifiable__container',
  items: 'react-notifiable__items',
  item: 'react-notifiable__item',
  itemTexts: 'react-notifiable__item-texts',
  itemTitle: 'react-notifiable__item-title',
  itemMessage: 'react-notifiable__item-message',
  itemActions: 'react-notifiable__item-actions'
};

var Container = function (_React$Component) {
  _inherits(Container, _React$Component);

  function Container(props, context) {
    _classCallCheck(this, Container);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Container).call(this, props));

    _this.theme = (0, _reactThemeable2.default)(props.theme || DEFAULT_THEME);

    if (props.notificationShape) {
      (0, _reducerAndActions.updateNotificationShape)(props.notificationShape);
    }

    if (context.store && context.store.getState().$$notifiable) {
      _this.store = context.store;
    } else {
      _this.store = (0, _redux.createStore)(_reducerAndActions2.default);
    }
    return _this;
  }

  _createClass(Container, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _notification2.default,
        { store: this.store, theme: this.theme },
        this.props.children
      );
    }
  }]);

  return Container;
}(_react2.default.Component);

Container.displayName = 'Container';
Container.propTypes = {
  children: _react.PropTypes.element,
  notificationShape: _react.PropTypes.object,
  theme: _react.PropTypes.object
};
Container.contextTypes = {
  store: _react.PropTypes.shape({
    subscribe: _react.PropTypes.func.isRequired,
    dispatch: _react.PropTypes.func.isRequired,
    getState: _react.PropTypes.func.isRequired
  })
};
exports.default = Container;