'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createMiddleware;

var _reducerAndActions = require('./reducerAndActions.js');

function createMiddleware(mapper) {
  return function (store) {
    return function (next) {
      return function (action) {
        if (mapper[action.type]) {
          store.dispatch(_reducerAndActions.actionCreators.notify(mapper[action.type]));
        }

        next(action);
      };
    };
  };
}