'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _nodeUuid = require('node-uuid');

var _nodeUuid2 = _interopRequireDefault(_nodeUuid);

var _reactRedux = require('react-redux');

var _items = require('./components/items');

var _items2 = _interopRequireDefault(_items);

var _reducerAndActions = require('./reducerAndActions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Notification = function (_React$Component) {
  _inherits(Notification, _React$Component);

  _createClass(Notification, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        __notify: this.notify,
        __closeNotification: this.closeNotification
      };
    }
  }]);

  function Notification() {
    _classCallCheck(this, Notification);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Notification).call(this));

    _this.notify = _this.notify.bind(_this);
    _this.closeNotification = _this.closeNotification.bind(_this);
    return _this;
  }

  _createClass(Notification, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var theme = _props.theme;
      var notifications = _props.$$notifiable.notifications;


      return _react2.default.createElement(
        'div',
        theme(1, 'container'),
        _react2.default.createElement(_items2.default, { notifications: notifications, theme: theme }),
        this.props.children
      );
    }
  }, {
    key: 'notify',
    value: function notify(notification) {
      var notify = this.props.notify;

      var id = _nodeUuid2.default.v4();

      notify(_extends({}, notification, { id: id }));

      return id;
    }
  }, {
    key: 'closeNotification',
    value: function closeNotification(id) {
      var closeNotification = this.props.closeNotification;


      closeNotification(id);
    }
  }]);

  return Notification;
}(_react2.default.Component);

Notification.displayName = 'Notification';
Notification.propTypes = {
  $$notifiable: _react.PropTypes.object,
  children: _react.PropTypes.element,
  notify: _react.PropTypes.func,
  closeNotification: _react.PropTypes.func,
  theme: _react.PropTypes.func.isRequired
};
Notification.childContextTypes = {
  __notify: _react2.default.PropTypes.func,
  __closeNotification: _react2.default.PropTypes.func
};


var mapStateToProps = function mapStateToProps(state) {
  return {
    $$notifiable: state.$$notifiable || state
  };
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, _reducerAndActions.actionCreators)(Notification);