'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.actionCreators = exports.NOTIFICATION_SHAPE = exports.CLOSE_NOTIFICATION = exports.NOTIFY = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.updateNotificationShape = updateNotificationShape;
exports.notify = notify;
exports.closeNotification = closeNotification;
exports.default = reducer;

var _uuid = require('uuid');

var _uuid2 = _interopRequireDefault(_uuid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var NOTIFY = exports.NOTIFY = '@@react-yell/NOTIFY';
var CLOSE_NOTIFICATION = exports.CLOSE_NOTIFICATION = '@@react-yell/CLOSE_NOTIFICATION';
var NOTIFICATION_SHAPE = exports.NOTIFICATION_SHAPE = {
  dismiss: true,
  dismissTimeout: 5000,
  actions: [{
    label: 'Dismiss'
  }],
  type: 'success',
  Template: null
};
var initialState = {
  notifications: []
};

function updateNotificationShape(template) {
  exports.NOTIFICATION_SHAPE = NOTIFICATION_SHAPE = _extends({}, NOTIFICATION_SHAPE, template);
}

function notify(n) {
  var id = n.id || _uuid2.default.v4();

  return {
    type: NOTIFY,
    notification: _extends({}, NOTIFICATION_SHAPE, n, {
      id: id
    })
  };
}

function closeNotification(id) {
  return {
    type: CLOSE_NOTIFICATION,
    id: id
  };
}

var actionCreators = exports.actionCreators = {
  notify: notify,
  closeNotification: closeNotification
};

function reducer() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? initialState : arguments[0];
  var action = arguments[1];

  switch (action.type) {
    case NOTIFY:
      state = {
        notifications: [].concat(_toConsumableArray(state.notifications), [action.notification])
      };
      return state;

    case CLOSE_NOTIFICATION:
      state = {
        notifications: state.notifications.filter(function (_ref) {
          var id = _ref.id;
          return id !== action.id;
        })
      };
      return state;

    default:
      return state;
  }
}